#import "SoundEffect.h"

SoundEffect*  createSysSnd(NSString * snd_name) {
	NSString * snd_type = @"wav";
	NSString * path = [[NSBundle mainBundle] pathForResource:snd_name ofType:snd_type];
	SoundEffect * res = 
		[[SoundEffect alloc] initWithContentsOfFile:path];
	[snd_name release];
	[snd_type release];
//	[path release];
	return res;
}

@implementation SoundEffect
+ (id)soundEffectWithContentsOfFile:(NSString *)aPath {
    if (aPath) {
        return [[[SoundEffect alloc] initWithContentsOfFile:aPath] autorelease];
    }
    return nil;
}

- (id)initWithContentsOfFile:(NSString *)path {
    self = [super init];
    
    if (self != nil) {
        NSURL *aFileURL = [NSURL fileURLWithPath:path isDirectory:NO];
        
        if (aFileURL != nil)  {
            SystemSoundID aSoundID;
            OSStatus error = AudioServicesCreateSystemSoundID((CFURLRef)aFileURL, &aSoundID);
            
			[aFileURL release];
			aFileURL = nil;
            if (error == kAudioServicesNoError) { // success
                _soundID = aSoundID;
            } else {
                NSLog(@"Error %d loading sound at path: %@", error, path);
                [self release], self = nil;
            }
        } else {
            NSLog(@"NSURL is nil for path: %@", path);
            [self release], self = nil;
        }
    }
    return self;
}

-(void)dealloc {
    AudioServicesDisposeSystemSoundID(_soundID);
    [super dealloc];
}

-(void)play {
	NSLog(@"playing sound");
    AudioServicesPlaySystemSound(_soundID);
}

@end